{
open Parser        (* The type token is defined in parser.mli *)
exception Eof
}
rule token = parse
  [' ' '\t']     { token lexbuf }     (* skip blanks *)
| ['\n' ';']     { EOL }
| "lambda"       { LAMBDA }
| '%'            { LAMBDA }
| "->"           { CURRY }
| '('            { LP }
| ')'            { RP }
| '.'            { DOT }
| '?'            { QM }
| '!'            { IM }
| ':'            { DP }
| ['a'-'z' 'A'-'Z']['a'-'z' 'A'-'Z' '0'-'9' '_']* 
                 {VAR (Lexing.lexeme lexbuf)}
| ['0'-'9']+
                 {INT (int_of_string (Lexing.lexeme lexbuf))}
| eof            { raise Eof }
