/* File parser.mly */
%{
open Defs
open Parser_aux
%}

%token <string> VAR
%token <int> INT
%token LAMBDA LP RP DOT EOL QM IM CURRY DP

%type <string Defs.term> term
%start term             /* the entry point       */
%type <string Defs.types> types
%start types             /* the entry point       */
%%    
term:
    lterm EOL {str_to_int ($1)}

lterm: 
    LAMBDA vars DOT lterm 
      {varlist ($4) ($2)}
  | lterm_ {$1}

lterm_:
    LP lterm RP {$2}
  | VAR {Var ($1)}
  | INT {nat_from_int $1}
  | IM VAR {Rec_const $2}
  | QM VAR DP types {add_type $2 $4; Unk ($2, $4)}
  | QM VAR {Unk ($2, find_type $2)}
  | QM INT {Unk (string_of_int $2, dummy_type)}
  | lterm_ lterm__ {App($1,$2)}

lterm__:
    LP lterm RP {$2}
  | VAR {Var ($1)}
  | INT {nat_from_int $1}
  | IM VAR {Rec_const $2}
  | QM VAR DP types {add_type $2 $4; Unk ($2, $4)}
  | QM VAR {Unk ($2, find_type $2)}
  | QM INT {Unk (string_of_int $2, dummy_type)}

vars:
    vars VAR {$2::$1}
  | VAR {[$1]}

types:
    typ CURRY types {Curry($1, $3)}
  | typ {$1}
      
typ:
  | LP types RP {$2}
  | VAR {Base $1}
