exception Empty

type 'a t = ('a list) * ('a list)

let nil = [], []

let create () = nil

let push (lb, le) a = lb, (a::le)

let pop = function
  | [], [] -> raise Empty
  | [], le -> let a::lb = List.rev le in a,(lb, [])
  | (x::lb), le -> x, (lb, le)

let is_empty = function
  | [], [] -> true
  | _ -> false

let from_list l = l, []

let to_list (lb, le) = List.rev_append lb le


let add_as_first (lb, le) a = (a ::lb), le

let map f (lb, le)=
  let rec aux = function
    | [] -> List.rev_map f le
    | x::q -> (f x)::(aux q) 
  in 
  aux lb, []

let iter f (lb, le) = 
  let rec rev_iter f = function
    | [] -> ()
    | x::q -> rev_iter f q; f x
  in
  List.iter f lb;
  rev_iter f le
